
if($ARGV[0] eq ""){
	print("Usage:\nperl stop_scan.pl <serial port>\n\n");
	exit(-1);
}

$cardname = "CANSNF";
$serial_port = $ARGV[0];



######################################################################
# init serial stuff
print("Init serial port \n");
@rc = SETUP_SERIAL($serial_port);
if($rc[0] != 0){
	exit($rc[0]);
}
$COMPORT = $rc[1];

#flush serial port buffers
$sendstring = "         ";	# garbage chars at start are to just flush out port
$count_out = $COMPORT->write($sendstring);
if(length($sendstring) != $count_out){
	print("Error send failed!!\n",$count_out," Sent out of ",length($sendstring),"\n");
	exit(-1);
}
# this code clears the read buffer (just read all the chars in until its empty)
$recv_length = 1;
$count_in = 1;
while ($count_in == 1){						
	($count_in, $recvstring) = $COMPORT->read($recv_length);
}

######################################################################
# Stop the card scanning loop
print("	Done\nStop scan\n");
$sendstring = $cardname.chr(0x08); 	# stop the auto scan of the mcp
$count_out = $COMPORT->write($sendstring);
if(length($sendstring) != $count_out){
	print("TX error on stop scan...\n");
	exit(-1);
}
$recv_length = 2;						# how many chars to get
($count_in, $recvstring) = $COMPORT->read($recv_length);
if($count_in != $recv_length || $recvstring ne (chr(0x0D).chr(0x0A))){	
	print("RX cnt error on stop scan...\n");
	print("count: ",$count_in,"\n");
	print("data: \n",unpack("H*",$recvstring),"\n");
	exit(-1);
}

print("	Done\n");
exit(0);

###############################################
# this function sets up the serial port
###############################################
sub SETUP_SERIAL{
	my $PortName = $_[0];
	my $COMPORT = "";

	require 5.003;
	if($^O =~ m/MSWIN32/i){
		#  ppm install http://www.bribes.org/perl/ppm/Win32-API.ppd
		require Win32::SerialPort; #(more info at http://members.aol.com/Bbirthisel/SerialPort.html)
		import Win32::SerialPort qw( :STAT 0.19 );

		# open the serial port  (more info at http://members.aol.com/Bbirthisel/SerialPort.html)
		$COMPORT = new Win32::SerialPort ($PortName) || die("Can't open ".$PortName.": ".$^E."\n");  
	}elsif($^O =~ m/linux/i){
		require Device::SerialPort; 
		import Device::SerialPort qw(:PARAM :STAT 0.07);
		# open the serial port 
		$COMPORT = new Device::SerialPort ($PortName) || die("Can't open ".$PortName.": ".$^E."\n");
	}else{
		print("Unknown operating system ",$^O," exiting.\n");
		exit(-1);
	}
	
	# configure the port
	$COMPORT->baudrate(115200);
#	$COMPORT->parity("even");
	$COMPORT->parity("none");
	$COMPORT->databits(8);
	$COMPORT->stopbits(1);
	$COMPORT->handshake("");
	$COMPORT->binary(T);          		# just say Yes (Win 3.x option)
#	$COMPORT->parity_enable(1);   
	if($^O =~ m/MSWIN32/i){
		$COMPORT->debug(0);	# prints msg in linux
		$COMPORT->write_char_time(50);		# needed for write timeouts
		$COMPORT->write_const_time(1000);	# needed for write timeouts
		$COMPORT->read_interval(1000);    	# needed for read timeouts max time between read char (milliseconds)
		$COMPORT->read_char_time(5);     	# needed for read timeouts avg time between read char
	}
	$COMPORT->read_const_time(1000);  	# needed for read timeouts total = (avg * bytes) + const 
	$COMPORT->buffers(4096, 4096);
	$COMPORT->write_settings;		# actualy use the settings above

	return(0,$COMPORT);
}


